﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Delicate : MonoBehaviour {

	private Vector3 lastFloorPoint;
	private Vector3 thisFloorPoint;
	private bool amHit;
	private bool lastclicked;
	float hoverHeight;

	Rigidbody r;

	// Use this for initialization
	void Start () {
		r = GetComponent<Rigidbody>();
		hoverHeight = transform.position.y + 1.0f;
		lastclicked = false;
	}

	void FixedUpdate () {

		if (amHit && lastclicked)
		{
			if (transform.position.y > hoverHeight) {
				Vector3 p = transform.position;
				p.y = hoverHeight;
				r.MovePosition(p);
				r.velocity = r.velocity - (r.velocity.y * Vector3.up);
			} else {
				Vector3 p = transform.position;
				p.y = p.y + (hoverHeight+0.2f-transform.position.y) * Time.deltaTime * 2.0f;
				r.MovePosition(p);
			}
							
			r.AddForce((50*(thisFloorPoint-lastFloorPoint)));

			r.AddForce(10.0f*Vector3.up);
			r.AddForce(-5.5f*r.velocity);


			//r.AddForce( Vector3.up * (10-transform.position.y) * 0.5f);
			//r.AddForce( (transform.position.y * r.velocity.y) * -Vector3.up);

			lastFloorPoint = thisFloorPoint;
		}
	}
	
	// Update is called once per frame
	void Update () {
		if (Input.GetMouseButtonDown(0)) {
			Ray ray = Camera.main.ScreenPointToRay(Input.mousePosition);

			RaycastHit[] hits = Physics.RaycastAll(ray);
			foreach(RaycastHit hit in hits)
			{
				if (hit.transform == transform)
				{
					lastclicked = true;
				}
				if (hit.transform.name == "room1")
				{
					lastFloorPoint = hit.point;
				}
			}
		}

		if (Input.GetMouseButton(0)) {
			bool floor = false;
			Vector3 maybeFloorPoint = Vector3.zero;
			bool maybeAmHit = false;
			Ray ray = Camera.main.ScreenPointToRay(Input.mousePosition);

			RaycastHit[] hits = Physics.RaycastAll(ray);
			foreach(RaycastHit hit in hits)
			{
				if (hit.transform == transform)
				{
					amHit = true;
				}
				else if (hit.transform.name == "room1")
				{
					thisFloorPoint = hit.point;
					floor = true;
				}
			}

			if (floor && maybeAmHit)
			{
				amHit = true;
				thisFloorPoint = maybeFloorPoint;
			}
		} else {
			amHit = false;
			lastclicked = false;
		}
	}

	void OnCollisionEnter(Collision col)
	{
		if (col.collider.gameObject.tag == "Player")
		{
			print("BANG");
			print (gameObject.name);
			Score score = (Score)FindObjectOfType(typeof(Score));
			score.Bonk();
		}
	}
}
