﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ElephantWalk : MonoBehaviour {

	new Rigidbody rigidbody;
	float walkspeed = 1.0f;
	float turnspeed = 5.0f;
	float movetime = 0.0f;
	float walkanimspeed = 4.0f;

	float currentspeed = 0.0f;

	Transform leg1;
	Transform leg2;
	Transform leg3;
	Transform leg4;

	// Use this for initialization
	void Start () {
		rigidbody = GetComponent<Rigidbody>();
		leg1 = transform.Find("leg1");
		leg2 = transform.Find("leg2");
		leg3 = transform.Find("leg3");
		leg4 = transform.Find("leg4");
	}
	
	// Update is called once per frame
	void FixedUpdate () {

		bool bMoving = false;

		float forward = 0.0f;
		if (Input.GetAxis("Vertical") > 0.1)
		{
			forward = 1.0f;
		}
		else if (Input.GetAxis("Vertical") < -0.1)
		{
			forward = -0.5f;
		}

		if (Input.GetAxis("Horizontal") < -0.1)
		{
			Quaternion turn = Quaternion.Euler(- transform.up * turnspeed * Time.deltaTime);
			rigidbody.rotation = rigidbody.rotation * turn;
			//rigidbody.MoveRotation(turn);
			forward = 0.3f;
		}
		if (Input.GetAxis("Horizontal") > 0.1)
		{
			Quaternion turn = Quaternion.Euler(transform.up * turnspeed * Time.deltaTime);
			rigidbody.rotation = rigidbody.rotation * turn;
			//rigidbody.MoveRotation(turn);
			forward = 0.3f;
		}

		forward = Mathf.Min(1.0f,forward);

		//if (forward != 0.0f)
		if (forward > 0.0f)
		{
			currentspeed = Mathf.Min(1, currentspeed + Time.deltaTime);
			rigidbody.MovePosition(transform.position + transform.forward*forward*walkspeed*currentspeed*Time.deltaTime);
			bMoving = true;
		}



		if (bMoving)
		{
			if (movetime == 0.0f) {
				float currentTime1 = Mathf.Asin(leg1.localPosition.y);
				float currentTime2 = Mathf.Asin(leg2.localPosition.y);
				movetime = Mathf.Max(currentTime1,currentTime2);
				if (currentTime2 != 0.0f) 
				{
					movetime += Mathf.PI;
				}
			}



			movetime += Time.deltaTime * walkanimspeed;
			leg1.localPosition = Mathf.Max(0.0f,  Mathf.Sin(movetime)) * Vector3.up + Mathf.Max(0.0f, -Mathf.Cos(movetime)) * 0.5f * forward * Mathf.Min(movetime,1.0f) * Vector3.forward;
			leg2.localPosition = Mathf.Max(0.0f, -Mathf.Sin(movetime)) * Vector3.up + Mathf.Max(0.0f,  Mathf.Cos(movetime)) * 0.5f * forward * Mathf.Min(movetime,1.0f) * Vector3.forward;
			leg3.localPosition = Mathf.Max(0.0f, -Mathf.Sin(movetime)) * Vector3.up + Mathf.Max(0.0f,  Mathf.Cos(movetime)) * 0.5f * forward * Mathf.Min(movetime,1.0f) * Vector3.forward;
			leg4.localPosition = Mathf.Max(0.0f,  Mathf.Sin(movetime)) * Vector3.up + Mathf.Max(0.0f, -Mathf.Cos(movetime)) * 0.5f * forward * Mathf.Min(movetime,1.0f) * Vector3.forward;

		}
		else
		{
			leg1.localPosition = leg1.localPosition * (1.0f-2*Time.deltaTime);
			leg2.localPosition = leg2.localPosition * (1.0f-2*Time.deltaTime);
			leg3.localPosition = leg3.localPosition * (1.0f-2*Time.deltaTime);
			leg4.localPosition = leg4.localPosition * (1.0f-2*Time.deltaTime);
			movetime = 0.0f;
			currentspeed = 0.0f;
		}
			
	}


}
